import{s as ye,n as xe,o as $e}from"../chunks/scheduler.7da89386.js";import{S as Ce,i as ze,g as i,s as a,r as m,A as Me,h as r,f as t,c as l,j as c,u as g,x as ae,k as p,y as b,a as n,v as f,d as _,t as h,w as v}from"../chunks/index.0b7befd3.js";import{D as y}from"../chunks/Docstring.80026b50.js";import{H as Ne,E as we}from"../chunks/EditOnGithub.0cb2bc8e.js";function ke(de){let u,G,W,j,x,R,s,$,le,L,me="Base configuration class for models.",ie,q,ce=`Methods:
<strong>post_init</strong>(): Performs post-initialization checks on the configuration.
_init_configs(model_name, env_config): Initializes the model configuration.
init_configs(env_config): Initializes the model configuration using the environment configuration.
get_model_sha(): Retrieves the SHA of the model.`,J,C,z,K,M,N,Q,w,k,X,T,O,Y,B,F,Z,I,D,ee,d,E,re,P,ge="Create a model configuration based on the provided arguments.",se,U,pe=`ValueError: If multichoice continuations both should start with a space and should not start with a space.
ValueError: If a base model is not specified when using delta weights or adapter weights.
ValueError: If a base model is specified when not using delta weights or adapter weights.`,te,A,oe,S,ne;return x=new Ne({props:{title:"ModelConfig",local:"lighteval.models.model_config.BaseModelConfig",headingTag:"h1"}}),$=new y({props:{name:"class lighteval.models.model_config.BaseModelConfig",anchor:"lighteval.models.model_config.BaseModelConfig",parameters:[{name:"pretrained",val:": str"},{name:"accelerator",val:": Accelerator = None"},{name:"tokenizer",val:": typing.Optional[str] = None"},{name:"multichoice_continuations_start_space",val:": typing.Optional[bool] = None"},{name:"pairwise_tokenization",val:": bool = False"},{name:"subfolder",val:": typing.Optional[str] = None"},{name:"revision",val:": str = 'main'"},{name:"batch_size",val:": int = -1"},{name:"max_gen_toks",val:": typing.Optional[int] = 256"},{name:"max_length",val:": typing.Optional[int] = None"},{name:"add_special_tokens",val:": bool = True"},{name:"model_parallel",val:": typing.Optional[bool] = None"},{name:"dtype",val:": typing.Union[str, torch.dtype, NoneType] = None"},{name:"device",val:": typing.Union[int, str] = 'cuda'"},{name:"quantization_config",val:": typing.Optional[transformers.utils.quantization_config.BitsAndBytesConfig] = None"},{name:"trust_remote_code",val:": bool = False"},{name:"use_chat_template",val:": bool = False"},{name:"compile",val:": bool = False"}],parametersDescription:[{anchor:"lighteval.models.model_config.BaseModelConfig.pretrained",description:`<strong>pretrained</strong> (str) &#x2014;
HuggingFace Hub model ID name or the path to a pre-trained
model to load. This is effectively the <code>pretrained_model_name_or_path</code>
argument of <code>from_pretrained</code> in the HuggingFace <code>transformers</code> API.`,name:"pretrained"},{anchor:"lighteval.models.model_config.BaseModelConfig.accelerator",description:"<strong>accelerator</strong> (Accelerator) &#x2014; accelerator to use for model training.",name:"accelerator"},{anchor:"lighteval.models.model_config.BaseModelConfig.tokenizer",description:`<strong>tokenizer</strong> (Optional[str]) &#x2014; HuggingFace Hub tokenizer ID that will be
used for tokenization.`,name:"tokenizer"},{anchor:"lighteval.models.model_config.BaseModelConfig.multichoice_continuations_start_space",description:`<strong>multichoice_continuations_start_space</strong> (Optional[bool]) &#x2014; Whether to add a
space at the start of each continuation in multichoice generation.
For example, context: &#x201C;What is the capital of France?&#x201D; and choices: &#x201C;Paris&#x201D;, &#x201C;London&#x201D;.
Will be tokenized as: &#x201C;What is the capital of France? Paris&#x201D; and &#x201C;What is the capital of France? London&#x201D;.
True adds a space, False strips a space, None does nothing`,name:"multichoice_continuations_start_space"},{anchor:"lighteval.models.model_config.BaseModelConfig.pairwise_tokenization",description:"<strong>pairwise_tokenization</strong> (bool) &#x2014; Whether to tokenize the context and continuation as separately or together.",name:"pairwise_tokenization"},{anchor:"lighteval.models.model_config.BaseModelConfig.subfolder",description:"<strong>subfolder</strong> (Optional[str]) &#x2014; The subfolder within the model repository.",name:"subfolder"},{anchor:"lighteval.models.model_config.BaseModelConfig.revision",description:"<strong>revision</strong> (str) &#x2014; The revision of the model.",name:"revision"},{anchor:"lighteval.models.model_config.BaseModelConfig.batch_size",description:"<strong>batch_size</strong> (int) &#x2014; The batch size for model training.",name:"batch_size"},{anchor:"lighteval.models.model_config.BaseModelConfig.max_gen_toks",description:"<strong>max_gen_toks</strong> (Optional[int]) &#x2014; The maximum number of tokens to generate.",name:"max_gen_toks"},{anchor:"lighteval.models.model_config.BaseModelConfig.max_length",description:"<strong>max_length</strong> (Optional[int]) &#x2014; The maximum length of the generated output.",name:"max_length"},{anchor:"lighteval.models.model_config.BaseModelConfig.add_special_tokens",description:`<strong>add_special_tokens</strong> (bool, optional, defaults to True) &#x2014; Whether to add special tokens to the input sequences.
If <code>None</code>, the default value will be set to <code>True</code> for seq2seq models (e.g. T5) and
<code>False</code> for causal models.`,name:"add_special_tokens"},{anchor:"lighteval.models.model_config.BaseModelConfig.model_parallel",description:`<strong>model_parallel</strong> (bool, optional, defaults to False) &#x2014;
True/False: force to use or not the <code>accelerate</code> library to load a large
model across multiple devices.
Default: None which corresponds to comparing the number of processes with
the number of GPUs. If it&#x2019;s smaller =&gt; model-parallelism, else not.`,name:"model_parallel"},{anchor:"lighteval.models.model_config.BaseModelConfig.dtype",description:`<strong>dtype</strong> (Union[str, torch.dtype], optional, defaults to None) &#x2014;):
Converts the model weights to <code>dtype</code>, if specified. Strings get
converted to <code>torch.dtype</code> objects (e.g. <code>float16</code> -&gt; <code>torch.float16</code>).
Use <code>dtype=&quot;auto&quot;</code> to derive the type from the model&#x2019;s weights.`,name:"dtype"},{anchor:"lighteval.models.model_config.BaseModelConfig.device",description:"<strong>device</strong> (Union[int, str]) &#x2014; device to use for model training.",name:"device"},{anchor:"lighteval.models.model_config.BaseModelConfig.quantization_config",description:`<strong>quantization_config</strong> (Optional[BitsAndBytesConfig]) &#x2014; quantization
configuration for the model, manually provided to load a normally floating point
model at a quantized precision. Needed for 4-bit and 8-bit precision.`,name:"quantization_config"},{anchor:"lighteval.models.model_config.BaseModelConfig.trust_remote_code",description:`<strong>trust_remote_code</strong> (bool) &#x2014; Whether to trust remote code during model
loading.`,name:"trust_remote_code"}],source:"https://github.com/huggingface/lighteval/blob/vr_412/src/lighteval/models/model_config.py#L48"}}),z=new y({props:{name:"class lighteval.models.model_config.AdapterModelConfig",anchor:"lighteval.models.model_config.AdapterModelConfig",parameters:[{name:"pretrained",val:": str"},{name:"accelerator",val:": Accelerator = None"},{name:"tokenizer",val:": typing.Optional[str] = None"},{name:"multichoice_continuations_start_space",val:": typing.Optional[bool] = None"},{name:"pairwise_tokenization",val:": bool = False"},{name:"subfolder",val:": typing.Optional[str] = None"},{name:"revision",val:": str = 'main'"},{name:"batch_size",val:": int = -1"},{name:"max_gen_toks",val:": typing.Optional[int] = 256"},{name:"max_length",val:": typing.Optional[int] = None"},{name:"add_special_tokens",val:": bool = True"},{name:"model_parallel",val:": typing.Optional[bool] = None"},{name:"dtype",val:": typing.Union[str, torch.dtype, NoneType] = None"},{name:"device",val:": typing.Union[int, str] = 'cuda'"},{name:"quantization_config",val:": typing.Optional[transformers.utils.quantization_config.BitsAndBytesConfig] = None"},{name:"trust_remote_code",val:": bool = False"},{name:"use_chat_template",val:": bool = False"},{name:"compile",val:": bool = False"},{name:"base_model",val:": str = None"}],source:"https://github.com/huggingface/lighteval/blob/vr_412/src/lighteval/models/model_config.py#L193"}}),N=new y({props:{name:"class lighteval.models.model_config.DeltaModelConfig",anchor:"lighteval.models.model_config.DeltaModelConfig",parameters:[{name:"pretrained",val:": str"},{name:"accelerator",val:": Accelerator = None"},{name:"tokenizer",val:": typing.Optional[str] = None"},{name:"multichoice_continuations_start_space",val:": typing.Optional[bool] = None"},{name:"pairwise_tokenization",val:": bool = False"},{name:"subfolder",val:": typing.Optional[str] = None"},{name:"revision",val:": str = 'main'"},{name:"batch_size",val:": int = -1"},{name:"max_gen_toks",val:": typing.Optional[int] = 256"},{name:"max_length",val:": typing.Optional[int] = None"},{name:"add_special_tokens",val:": bool = True"},{name:"model_parallel",val:": typing.Optional[bool] = None"},{name:"dtype",val:": typing.Union[str, torch.dtype, NoneType] = None"},{name:"device",val:": typing.Union[int, str] = 'cuda'"},{name:"quantization_config",val:": typing.Optional[transformers.utils.quantization_config.BitsAndBytesConfig] = None"},{name:"trust_remote_code",val:": bool = False"},{name:"use_chat_template",val:": bool = False"},{name:"compile",val:": bool = False"},{name:"base_model",val:": str = None"}],source:"https://github.com/huggingface/lighteval/blob/vr_412/src/lighteval/models/model_config.py#L176"}}),k=new y({props:{name:"class lighteval.models.model_config.InferenceEndpointModelConfig",anchor:"lighteval.models.model_config.InferenceEndpointModelConfig",parameters:[{name:"model_or_endpoint_name",val:": str"},{name:"should_reuse_existing",val:": bool = False"},{name:"accelerator",val:": str = 'gpu'"},{name:"model_dtype",val:": str = None"},{name:"vendor",val:": str = 'aws'"},{name:"region",val:": str = 'us-east-1'"},{name:"instance_size",val:": str = None"},{name:"instance_type",val:": str = None"},{name:"framework",val:": str = 'pytorch'"},{name:"endpoint_type",val:": str = 'protected'"},{name:"add_special_tokens",val:": bool = True"},{name:"revision",val:": str = 'main'"},{name:"namespace",val:": str = None"},{name:"image_url",val:": str = None"},{name:"env_vars",val:": dict = None"}],source:"https://github.com/huggingface/lighteval/blob/vr_412/src/lighteval/models/model_config.py#L258"}}),O=new y({props:{name:"class lighteval.models.model_config.InferenceModelConfig",anchor:"lighteval.models.model_config.InferenceModelConfig",parameters:[{name:"model",val:": str"},{name:"add_special_tokens",val:": bool = True"}],source:"https://github.com/huggingface/lighteval/blob/vr_412/src/lighteval/models/model_config.py#L252"}}),F=new y({props:{name:"class lighteval.models.model_config.TGIModelConfig",anchor:"lighteval.models.model_config.TGIModelConfig",parameters:[{name:"inference_server_address",val:": str"},{name:"inference_server_auth",val:": str"},{name:"model_id",val:": str"}],source:"https://github.com/huggingface/lighteval/blob/vr_412/src/lighteval/models/model_config.py#L240"}}),D=new y({props:{name:"class lighteval.models.model_config.VLLMModelConfig",anchor:"lighteval.models.model_config.VLLMModelConfig",parameters:[{name:"pretrained",val:": str"},{name:"gpu_memory_utilisation",val:": float = 0.9"},{name:"revision",val:": str = 'main'"},{name:"dtype",val:": str | None = None"},{name:"tensor_parallel_size",val:": int = 1"},{name:"pipeline_parallel_size",val:": int = 1"},{name:"data_parallel_size",val:": int = 1"},{name:"max_model_length",val:": int | None = None"},{name:"swap_space",val:": int = 4"},{name:"seed",val:": int = 1234"},{name:"trust_remote_code",val:": bool = False"},{name:"use_chat_template",val:": bool = False"},{name:"add_special_tokens",val:": bool = True"},{name:"multichoice_continuations_start_space",val:": bool = True"},{name:"pairwise_tokenization",val:": bool = False"},{name:"subfolder",val:": typing.Optional[str] = None"},{name:"temperature",val:": float = 0.6"}],source:"https://github.com/huggingface/lighteval/blob/vr_412/src/lighteval/models/model_config.py#L211"}}),E=new y({props:{name:"lighteval.models.model_config.create_model_config",anchor:"lighteval.models.model_config.create_model_config",parameters:[{name:"use_chat_template",val:": bool"},{name:"override_batch_size",val:": int"},{name:"accelerator",val:": typing.Optional[ForwardRef('Accelerator')]"},{name:"model_args",val:": typing.Union[str, dict] = None"},{name:"model_config_path",val:": str = None"}],parametersDescription:[{anchor:"lighteval.models.model_config.create_model_config.accelerator(Union[Accelerator,",description:"<strong>accelerator(Union[Accelerator,</strong> None]) &#x2014; accelerator to use for model training.",name:"accelerator(Union[Accelerator,"},{anchor:"lighteval.models.model_config.create_model_config.use_chat_template",description:"<strong>use_chat_template</strong> (bool) &#x2014; whether to use the chat template or not. Set to True for chat or ift models",name:"use_chat_template"},{anchor:"lighteval.models.model_config.create_model_config.override_batch_size",description:"<strong>override_batch_size</strong> (int) &#x2014; frozen batch size to use",name:"override_batch_size"},{anchor:"lighteval.models.model_config.create_model_config.model_args",description:`<strong>model_args</strong> (Optional[Union[str, dict]]) &#x2014; Parameters to create the model, passed as a string (like the CLI kwargs or dict).
This option only allows to create a dummy model using <code>dummy</code> or a base model (using accelerate or no accelerator), in
which case corresponding full model args available are the arguments of the [[BaseModelConfig]].
Minimal configuration is <code>pretrained=&lt;name_of_the_model_on_the_hub&gt;</code>.`,name:"model_args"},{anchor:"lighteval.models.model_config.create_model_config.model_config_path",description:`<strong>model_config_path</strong> (Optional[str]) &#x2014; Path to the parameters to create the model, passed as a config file. This allows to create
all possible model configurations (base, adapter, peft, inference endpoints, tgi&#x2026;)`,name:"model_config_path"}],source:"https://github.com/huggingface/lighteval/blob/vr_412/src/lighteval/models/model_config.py#L301",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>model configuration.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p>Union[BaseModelConfig, AdapterModelConfig, DeltaModelConfig, TGIModelConfig, InferenceEndpointModelConfig, DummyModelConfig]</p>
`,raiseDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<ul>
<li><code>ValueError</code> — If both an inference server address and model arguments are provided.</li>
</ul>
`,raiseType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>ValueError</code></p>
`}}),A=new we({props:{source:"https://github.com/huggingface/lighteval/blob/main/docs/source/package_reference/model_config.mdx"}}),{c(){u=i("meta"),G=a(),W=i("p"),j=a(),m(x.$$.fragment),R=a(),s=i("div"),m($.$$.fragment),le=a(),L=i("p"),L.textContent=me,ie=a(),q=i("p"),q.innerHTML=ce,J=a(),C=i("div"),m(z.$$.fragment),K=a(),M=i("div"),m(N.$$.fragment),Q=a(),w=i("div"),m(k.$$.fragment),X=a(),T=i("div"),m(O.$$.fragment),Y=a(),B=i("div"),m(F.$$.fragment),Z=a(),I=i("div"),m(D.$$.fragment),ee=a(),d=i("div"),m(E.$$.fragment),re=a(),P=i("p"),P.textContent=ge,se=a(),U=i("p"),U.textContent=pe,te=a(),m(A.$$.fragment),oe=a(),S=i("p"),this.h()},l(e){const o=Me("svelte-u9bgzb",document.head);u=r(o,"META",{name:!0,content:!0}),o.forEach(t),G=l(e),W=r(e,"P",{}),c(W).forEach(t),j=l(e),g(x.$$.fragment,e),R=l(e),s=r(e,"DIV",{class:!0});var V=c(s);g($.$$.fragment,V),le=l(V),L=r(V,"P",{"data-svelte-h":!0}),ae(L)!=="svelte-rh03fc"&&(L.textContent=me),ie=l(V),q=r(V,"P",{"data-svelte-h":!0}),ae(q)!=="svelte-mdcuay"&&(q.innerHTML=ce),V.forEach(t),J=l(e),C=r(e,"DIV",{class:!0});var fe=c(C);g(z.$$.fragment,fe),fe.forEach(t),K=l(e),M=r(e,"DIV",{class:!0});var _e=c(M);g(N.$$.fragment,_e),_e.forEach(t),Q=l(e),w=r(e,"DIV",{class:!0});var he=c(w);g(k.$$.fragment,he),he.forEach(t),X=l(e),T=r(e,"DIV",{class:!0});var ve=c(T);g(O.$$.fragment,ve),ve.forEach(t),Y=l(e),B=r(e,"DIV",{class:!0});var ue=c(B);g(F.$$.fragment,ue),ue.forEach(t),Z=l(e),I=r(e,"DIV",{class:!0});var be=c(I);g(D.$$.fragment,be),be.forEach(t),ee=l(e),d=r(e,"DIV",{class:!0});var H=c(d);g(E.$$.fragment,H),re=l(H),P=r(H,"P",{"data-svelte-h":!0}),ae(P)!=="svelte-19st0js"&&(P.textContent=ge),se=l(H),U=r(H,"P",{"data-svelte-h":!0}),ae(U)!=="svelte-ydithz"&&(U.textContent=pe),H.forEach(t),te=l(e),g(A.$$.fragment,e),oe=l(e),S=r(e,"P",{}),c(S).forEach(t),this.h()},h(){p(u,"name","hf:doc:metadata"),p(u,"content",Te),p(s,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(C,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(M,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(w,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(T,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(B,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(I,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(d,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,o){b(document.head,u),n(e,G,o),n(e,W,o),n(e,j,o),f(x,e,o),n(e,R,o),n(e,s,o),f($,s,null),b(s,le),b(s,L),b(s,ie),b(s,q),n(e,J,o),n(e,C,o),f(z,C,null),n(e,K,o),n(e,M,o),f(N,M,null),n(e,Q,o),n(e,w,o),f(k,w,null),n(e,X,o),n(e,T,o),f(O,T,null),n(e,Y,o),n(e,B,o),f(F,B,null),n(e,Z,o),n(e,I,o),f(D,I,null),n(e,ee,o),n(e,d,o),f(E,d,null),b(d,re),b(d,P),b(d,se),b(d,U),n(e,te,o),f(A,e,o),n(e,oe,o),n(e,S,o),ne=!0},p:xe,i(e){ne||(_(x.$$.fragment,e),_($.$$.fragment,e),_(z.$$.fragment,e),_(N.$$.fragment,e),_(k.$$.fragment,e),_(O.$$.fragment,e),_(F.$$.fragment,e),_(D.$$.fragment,e),_(E.$$.fragment,e),_(A.$$.fragment,e),ne=!0)},o(e){h(x.$$.fragment,e),h($.$$.fragment,e),h(z.$$.fragment,e),h(N.$$.fragment,e),h(k.$$.fragment,e),h(O.$$.fragment,e),h(F.$$.fragment,e),h(D.$$.fragment,e),h(E.$$.fragment,e),h(A.$$.fragment,e),ne=!1},d(e){e&&(t(G),t(W),t(j),t(R),t(s),t(J),t(C),t(K),t(M),t(Q),t(w),t(X),t(T),t(Y),t(B),t(Z),t(I),t(ee),t(d),t(te),t(oe),t(S)),t(u),v(x,e),v($),v(z),v(N),v(k),v(O),v(F),v(D),v(E),v(A,e)}}}const Te='{"title":"ModelConfig","local":"lighteval.models.model_config.BaseModelConfig","sections":[],"depth":1}';function Oe(de){return $e(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ee extends Ce{constructor(u){super(),ze(this,u,Oe,ke,ye,{})}}export{Ee as component};
